/****************************************************************************
** $Id: qdataschemadriverplugin.h,v 1.1 2006/02/22 19:26:55 leader Exp $
**
** QT Data schema driver plugin object header file of
**
** Created : 20031201
**
** Copyright (C) 2003-2004 Leader InfoTech.  All rights reserved.
** Copyright (C) 2003-2005 Grigory Panov, Yoshkar-Ola.
**
** This file is part of the Designer application of the Ananas
** automation accounting system.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.leaderit.ru/page=ananas or email sales@leaderit.ru
** See http://www.leaderit.ru/gpl/ for GPL licensing information.
**
** Contact org@leaderit.ru if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef QDATASCHEMADRIVERPLUGIN_H
#define QDATASCHEMADRIVERPLUGIN_H

#ifndef QT_H
#include "qgplugin.h"
#include "qstringlist.h"
#endif // QT_H
#include "qdataschemaglobal.h"
#include <qobject.h>

#ifndef QT_NO_COMPONENT

class QDataSchemaDriver;
class QDataSchemaDriverPluginPrivate;

//#define TE_EXPORT_PLUGIN(pluginobjectname) typedef TEPlugin<pluginobjectname> pluginobjectname##Plugin; Q_EXPORT_PLUGIN(pluginobjectname)
#define QDATASCHEMADRIVER_EXPORT_PLUGIN(pluginobjectname) Q_EXPORT_PLUGIN(pluginobjectname)

/**
 * \en
 * Class for work with extensions
 * \_en
 * \ru
 * \_ru
 */
class  LIB_EXPORT QDataSchemaDriverPluginBase : public QGPlugin
{
    Q_OBJECT
public:

    QDataSchemaDriverPluginBase();
    ~QDataSchemaDriverPluginBase();
    virtual QStringList keys() const = 0;
    virtual QDataSchemaDriver *create( const QString &key ) = 0;

private:
    QDataSchemaDriverPluginPrivate *d;
};


template<class type>
class QDataSchemaDriverPlugin : public QDataSchemaDriverPluginBase
{
//    Q_OBJECT
public:

    QDataSchemaDriverPlugin()
    { 
	type o;
	extName = o.name();
    };
    ~QDataSchemaDriverPlugin(){};
    QStringList keys() const 
    {
        QStringList l;
	l << extName;
	return l;
    };
    QDataSchemaDriver *create( const QString &key ) 
    {
        if (key == extName) return new type();
	return 0;
    };
private:
    QString extName;
};

#endif // QT_NO_COMPONENT
#endif //QDATASCHEMADRIVERPLUGIN_H
