/****************************************************************************
** $Id: qdataschemaglobal.h,v 1.11 2007/01/06 17:43:25 leader Exp $
**
** QT Data Schema project
**
** Copyright (C) 1999-2006 Leader InfoTech.  All rights reserved.
** Copyright (C) 1999-2006 Valery Grazdankin.  All rights reserved.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.leaderit.ru/ or email sales@leaderit.ru
**
**********************************************************************/

/*!
 * \en
 * \mainpage QDataSchema - class for updates application and database server data structure actualy.
 *
 * \section intro Introduce
 *
 * Used for support syncronous data structure in application
 * and database server. Application data structure describes in
 * database server independed context. In depends of the
 * database server, chose method for structure updates if
 * structure of the application information was changed ( for
 * example, we wer updated application version ) and we need
 * updates data base structure with save information, that
 * was collected earlier.
 *
 * \section sql_servers Database servers supports:
 *
 * \li \b SQLite
 * \li \b MySQL
 * \li \b PostgreSQL
 *
 * \section futures Futures:
 *
 * \li (in translate)
 * \li (in translate)
 *
 * \section copyright Developers
 *
 * \_en \ru
 * \mainpage QDataSchema - класс для поддержки синхронной структуры базы данных
 *
 * \section intro Введение
 *
 * Используется для поддержки синхронной структуры данных
 * приложения и сервера базы данных. Структура данных
 * приложения описывается в серверо-независимом контексте.
 * В зависимости от конкретного сервера базы данных
 * выбирается способ обновления структуры в том случае, если
 * структура информации в приложении изменилась ( например,
 * обновлена версия приложения ) и нам требуется обновить
 * структуру базы данных, сохранив ранее введенную информацию.
 *
 * \section sql_servers Поддерживаемые базы данных:
 *
 * \li \b SQLite
 * \li \b MySQL
 * \li \b PostgreSQL
 *
 * \section futures Возможности:
 *
 * \li Поддерживает работу с пространствами имен. Это позволяет
 * в одной базе данных иметь несколько схем в разных пространствах
 * имен, то есть фактически несколько виртуальных баз данных внутри
 * одной физической.
 * \li Поддерживает экспорт содержимого базы данных в серверонезависимом
 * формате, что позволяет легко переносить данные между поддерживаемыми
 * серверами баз данных.
 *
 *
 * \section copyright Разработчики
 *
 * \_ru
 *
 * (c) 2004-2007 Leader IT, Orenburg, Russia
 *
 * (c) 2004-2007 Valery Grazdankin, Orenburg, Russia
 *
 */

#ifndef QDATASCHEMAGLOBAL_H
#define QDATASCHEMAGLOBAL_H
#include <qglobal.h>

#ifdef Q_OS_WIN32
#	include <windows.h>
#	include <math.h>
#endif
#ifdef Q_OS_UNIX
#	include <unistd.h>
#endif

#if defined(Q_OS_WIN32) && !defined(LIB_NO_DLL)
#  define LIB_DLLIMPORT __declspec(dllimport)
#  define LIB_DLLEXPORT __declspec(dllexport)
#else
#  define LIB_DLLIMPORT
#  define LIB_DLLEXPORT
#endif

#if defined (Q_CC_MSVC)
#define TEMPLATE_EXTERN extern
#else
#define TEMPLATE_EXTERN
#endif

#ifdef QDATASCHEMA_EXPORT
#  define LIB_EXPORT LIB_DLLEXPORT
#else
#  define LIB_EXPORT LIB_DLLIMPORT
#endif

#ifdef QDATASCHEMA_EXPORT
#  define LIB_TEMPLATE_EXTERN
#else
#  define LIB_TEMPLATE_EXTERN TEMPLATE_EXTERN
#endif

#if defined(Q_CC_MSVC)
#  define vsnprintf _vsnprintf
#endif

/*!
 *\class QDS qdsglobal.h
 *\en
 * \brief The QDS class is a namespace for miscellaneous
 * identifiers that need to be global-like in QDataSchema
 * objects.
 *
 *
 *\_en \ru
 * \brief Пространство имен QDataSchema.
 *
 *
 * \_ru
 *
 */
class QDS
{
public:
/*!
 * Define Meta Object types.
 */
    enum MO_Type { MO_ROOT, MO_CLASS, MO_ATTR, MO_RELATION };

};

/*
#include <qvariant.h>
class QDSVariant : public QVariant
{
public:
    enum Type {
    Invalid, Object
    };

    QDSVariant():QVariant(){};
    ~QDSVariant(){};
};
*/
#endif
