/****************************************************************************
** $Id: qdataschemainterface_p.h,v 1.2 2006/07/23 03:49:07 leader Exp $
**
** Definition of QDataSchemaInterface class
**
** Created : 20060209
**
** Copyright (C) 2003-2006 Leader InfoTech.  All rights reserved.
**
** This file is part of the Library of the Ananas
** automation accounting system.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.leaderit.ru/page=ananas or email sales@leaderit.ru
** See http://www.leaderit.ru/gpl/ for GPL licensing information.
**
** Contact org@leaderit.ru if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef QDATASCHEMAINTERFACE_P_H
#define QDATASCHEMAINTERFACE_P_H

#include <qdataschemaglobal.h>
#ifndef QT_H
#include <private/qcom_p.h>
#endif // QT_H

#ifndef QT_NO_COMPONENT

// {d8d98fd0-3ffa-4731-b358-ea4a65ea98c8}
#ifndef IID_QDataSchemaDriverFactory
#define IID_QDataSchemaDriverFactory QUuid(0xd8d98fd0, 0x3ffa, 0x4731, 0xb3, 0x58, 0xea, 0x4a, 0x65, 0xea, 0x98, 0xc8)
#endif

// {4ecf952a-5ef3-4c9e-a581-c9e8ba84085d}
#ifndef IID_QDataSchemaFactory
#define IID_QDataSchemaFactory QUuid(0x4ecf952a, 0x5ef3, 0x4c9e, 0xa5, 0x81, 0xc9, 0xe8, 0xba, 0x84, 0x08, 0x5d)
#endif

class QDataSchemaDriver;
class QObject;

struct LIB_EXPORT QDataSchemaDriverFactoryInterface : public QFeatureListInterface
{
    virtual QDataSchemaDriver* create( const QString& name ) = 0;
};

struct LIB_EXPORT QDataSchemaFactoryInterface : public QFeatureListInterface
{
    virtual QObject* create( const QString& name ) = 0;
};

#endif //QT_NO_COMPONENT
#endif // QDATASCHEMAINTERFACE_P_H
